Jessica Wagantall | 48a6b4c | 2021-08-02 20:19:36 -0700 | [diff] [blame] | 1 | #!/bin/bash |
| 2 | # SPDX-License-Identifier: EPL-1.0 |
| 3 | ############################################################################## |
| 4 | # Copyright (c) 2017 The Linux Foundation and others. |
| 5 | # |
| 6 | # All rights reserved. This program and the accompanying materials |
| 7 | # are made available under the terms of the Eclipse Public License v1.0 |
| 8 | # which accompanies this distribution, and is available at |
| 9 | # http://www.eclipse.org/legal/epl-v10.html |
| 10 | ############################################################################## |
| 11 | echo "---> oom-create-netrc.sh" |
| 12 | |
| 13 | if [ -z "$ALT_DOCKER_URL" ]; then |
| 14 | DOCKER_URL="${DOCKER_REGISTRY:-$DOCKER_URL}" |
| 15 | else |
| 16 | DOCKER_URL="${ALT_DOCKER_URL}" |
| 17 | fi |
| 18 | CREDENTIAL=$(xmlstarlet sel -N "x=http://maven.apache.org/SETTINGS/1.0.0" \ |
| 19 | -t -m "/x:settings/x:servers/x:server[x:id='${SERVER_ID}']" \ |
| 20 | -v x:username -o ":" -v x:password \ |
| 21 | "$SETTINGS_FILE") |
| 22 | |
| 23 | # Ensure we fail the job if any steps fail. |
| 24 | set -eu -o pipefail |
| 25 | |
| 26 | # Handle when a project chooses to not archive logs to a log server |
| 27 | # in other cases if CREDENTIAL is not found then fail the build. |
| 28 | if [ -z "$CREDENTIAL" ] && [ "$SERVER_ID" == "logs" ]; then |
| 29 | echo "WARN: Log server credential not found." |
| 30 | exit 0 |
| 31 | elif [ -z "$CREDENTIAL" ] && [ "$SERVER_ID" == "ossrh" ]; then |
| 32 | echo "WARN: OSSRH credentials not found." |
| 33 | echo " This is needed for staging to Maven Central." |
| 34 | exit 0 |
| 35 | elif [ -z "$CREDENTIAL" ]; then |
| 36 | echo "ERROR: Credential not found." |
| 37 | exit 1 |
| 38 | fi |
| 39 | |
| 40 | if [ "$SERVER_ID" == "ossrh" ]; then |
| 41 | machine="oss.sonatype.org" |
| 42 | else |
Jessica Wagantall | 940d782 | 2021-08-03 18:57:25 -0700 | [diff] [blame] | 43 | machine=$(echo "$DOCKER_URL") |
Jessica Wagantall | 48a6b4c | 2021-08-02 20:19:36 -0700 | [diff] [blame] | 44 | fi |
| 45 | |
| 46 | user=$(echo "$CREDENTIAL" | cut -f1 -d:) |
| 47 | pass=$(echo "$CREDENTIAL" | cut -f2 -d:) |
| 48 | |
| 49 | set +x # Disable `set -x` to prevent printing passwords |
| 50 | echo "machine ${machine%:*} login $user password $pass" >> ~/.netrc |